/*Vánoční stromeček s WS2812B
 * verze: 3x07.12.2018
 * Václav Doškář
 * email: doskar.vaclav@seznam.cz 
 */
 //připojení knihovny + definice porměnných
#include <Adafruit_NeoPixel.h>
// datový pin pro WS2812B
#define pinDI 5
// definováno tlačítko na pin 2 (interrupt 0)
#define tlacitko 2
// pocet připojených LED v sérii
#define pocetLED 16
// inicializace diod z knihovny
Adafruit_NeoPixel rgbWS = Adafruit_NeoPixel(pocetLED, pinDI, NEO_GRB + NEO_KHZ800);
// časové prodleva pro většinu efektů
#define cas 40
//deklarace proměnných
int ledka[15]={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
int rezim=0;
int jas=70;
int LED;
byte R,G,B,i;
int MAX=jas;

unsigned long millisted,millisCas;

// funkce pro ovládání barev diod
void nastavRGB (byte r, byte b, byte g, int cislo) {
  uint32_t barva;
  barva = rgbWS.Color(r, g, b);
  rgbWS.setPixelColor(cislo-1, barva);
   rgbWS.show();
}
// funkce pro SW restart
void(* resetFunc) (void) = 0;

// efekt intro
void prvni(){
  R=2;
  G=0;
  B=0;
  while(R<jas){
   R++;
   G++;
   
  delay(100);
  nastavRGB (R, G, B, ledka[6]);
  }
  nastavRGB (jas, jas, jas, ledka[5]);
  nastavRGB (jas, jas, jas, ledka[7]);
  delay(250);

    nastavRGB (jas, jas, jas, ledka[8]);
  delay(250);
    nastavRGB (jas, jas, jas, ledka[9]);
   nastavRGB (jas, jas, jas, ledka[4]);
     delay(250);

   nastavRGB (jas, jas, jas, ledka[3]);
  nastavRGB (jas, jas, jas, ledka[10]);
  delay(250);
  nastavRGB (jas, jas, jas, ledka[2]);
  nastavRGB (jas, jas, jas, ledka[12]);
  delay(250);
   nastavRGB (jas, jas, jas, ledka[1]);
  nastavRGB (jas, jas, jas, ledka[13]);
  delay(250);
   nastavRGB (jas, jas, jas, ledka[0]);
  nastavRGB (jas, jas, jas, ledka[14]);
  delay(250);
  
  }
  
    

// efekt 1: náhodný režim (dioda,barva);
void RNDM(){
  for (LED=0;LED<pocetLED;LED++){ 
nastavRGB(R, B  , G  , LED);  
R=random(MAX);
B=random(MAX);
G=random(MAX);
delay(cas);}
  }

// efekt 2: překlápění barev
void RGB(){
  // červená
 for (LED=0;LED<pocetLED;LED++){ 
  nastavRGB(jas, 0  , 0  , LED);
delay(cas);}
  
  //modrá
  for (LED=0;LED<pocetLED;LED++){ 
  nastavRGB(0, jas  , 0  , LED);
delay(cas);}
  
  //zelená
 for (LED=0;LED<pocetLED;LED++){ 
  nastavRGB(0, 0  , jas  , LED);
delay(cas);}
  
  //fialová
   for (LED=0;LED<pocetLED;LED++){ 
  nastavRGB(jas, jas  , 0  , LED);
delay(cas);}
  
  // tyrkysová
  for (LED=0;LED<pocetLED;LED++){ 
  nastavRGB(0, jas  , jas  , LED);
delay(cas);}

//žlutá
  for (LED=0;LED<pocetLED;LED++){ 
  nastavRGB(jas,  0 , jas  , LED);
delay(cas);}

  //bílá
 for (LED=0;LED<pocetLED;LED++){ 
  nastavRGB(jas, jas  , jas  , LED);
 delay(cas);}
 
  //žádná - vynulování
 for (LED=0;LED<pocetLED;LED++){ 
  nastavRGB(0, 0  , 0  , LED);
delay(cas);}
}

// efekt 3: Pomalý náhodný režim (slow random)
void SRND(){  
R=random(0,70);
G=random(0,70);
B=random(0,70);

byte A=random(0,16);
  nastavRGB (R, B, G, ledka[A]);
  nastavRGB (R, B, G, ledka[A]);

  nastavRGB (R, B, G, ledka[A]);
  nastavRGB (R, B, G, ledka[A]);

  nastavRGB (R, B, G, ledka[A]);
  nastavRGB (R, B, G, ledka[A]);

  delay(100);
}
    
//efekt 4: stmívání RGB

void RRGGBB(){
  for ( i=0; i<jas;i++){
 nastavRGB (i,  0,  0, ledka[0]);
 nastavRGB (i,  0,  0, ledka[3]);
 nastavRGB (i,  0,  0, ledka[6]);
 nastavRGB (i,  0,  0, ledka[9]);
 nastavRGB (i,  0,  0, ledka[12]);
 nastavRGB (i,  0,  0, ledka[15]);
 delay(cas);
  }
   for ( i=0; i<jas;i++){
 nastavRGB (0,  i,  0, ledka[1]);
 nastavRGB (0,  i,  0, ledka[4]);
 nastavRGB (0,  i,  0, ledka[7]);
 nastavRGB (0,  i,  0, ledka[10]);
 nastavRGB (0,  i,  0, ledka[13]);
 delay(cas);
  }
  for ( i=0; i<jas;i++){
 nastavRGB (0,  0,  i, ledka[2]);
 nastavRGB (0,  0,  i, ledka[5]);
 nastavRGB (0,  0,  i, ledka[8]);
 nastavRGB (0,  0,  i, ledka[11]);
 nastavRGB (0,  0,  i, ledka[14]);
 delay(cas);
  }
  for ( i=jas; i>0;i--){
 nastavRGB (i,  0,  0, ledka[0]);
 nastavRGB (i,  0,  0, ledka[3]);
 nastavRGB (i,  0,  0, ledka[6]);
 nastavRGB (i,  0,  0, ledka[9]);
 nastavRGB (i,  0,  0, ledka[12]);
 nastavRGB (i,  0,  0, ledka[15]);
 delay(cas);
 }
 for ( i=jas; i>0;i--){
 nastavRGB (0,  i,  0, ledka[1]);
 nastavRGB (0,  i,  0, ledka[4]);
 nastavRGB (0,  i,  0, ledka[7]);
 nastavRGB (0,  i,  0, ledka[10]);
 nastavRGB (0,  i,  0, ledka[13]);
 delay(cas);
  }

for ( i=jas; i>0;i--){
 nastavRGB (0,  0,  i, ledka[2]);
 nastavRGB (0,  0,  i, ledka[5]);
 nastavRGB (0,  0,  i, ledka[8]);
 nastavRGB (0,  0,  i, ledka[11]);
 nastavRGB (0,  0,  i, ledka[14]);
 delay(cas);
  }
    }

void setup() {
   rgbWS.begin();
pinMode(tlacitko,INPUT_PULLUP);
attachInterrupt(digitalPinToInterrupt(tlacitko),resetFunc,LOW);

for (LED=0;LED<pocetLED;LED++){ 
  nastavRGB(0, 0  , 0  , LED);
  while((millis()-millisted)<cas){}
  millisted=millis();}

 prvni();

}

void loop() {
 

millisCas = millis();
while((millis()-millisCas)<15000) {RNDM();}
  
millisCas = millis();
while((millis()-millisCas)<15000) {RGB();}

for (LED=0;LED<pocetLED;LED++){ 
  nastavRGB(0, 0  , 0  , LED);
  }
  
millisCas = millis();
while((millis()-millisCas)<15000) {SRND();}

for (LED=0;LED<pocetLED;LED++){ 
  nastavRGB(0, 0  , 0  , LED);
  }
  
millisCas = millis();
while((millis()-millisCas)<20000) {RRGGBB();}


  }
 
